﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ArmoredCar
{
    internal class EntityTank : EntityArmoredCar
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        /// Признак наличия башни с орудием
        /// </summary>
        public bool TowerWeapon { get; private set; }
        /// <summary>
        /// Признак наличия зенитного пулемета
        /// </summary>
        public bool AMachineGun { get; private set; }

        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес бронированной машины</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="towerWeapon">Признак наличия башни с орудием</param>
        /// <param name="aMachineGun">Признак наличия зенитного пулемета</param>
        public EntityTank(int speed, float weight, Color bodyColor, Color
       dopColor, bool towerWeapon, bool aMachineGun) :
        base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            TowerWeapon = towerWeapon;
            AMachineGun = aMachineGun;
        }
    }
}
