﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ArmoredCar
{
    internal class SetArmoredCarsGeneric<T>
        where T : class
    {
        /// <summary>
        /// Массив объектов, которые храним
        /// </summary>
        private readonly T[] _places;
        /// <summary>
        /// Количество объектов в массиве
        /// </summary>
        public int Count => _places.Length;
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="count"></param>
        public SetArmoredCarsGeneric(int count)
        {
            _places = new T[count];
        }
        /// <summary>
        /// Добавление объекта в набор
        /// </summary>
        /// <param name="armoredCar">Добавляемый автомобиль</param>
        /// <returns></returns>
        public int Insert(T armoredCar)
        {            
            return Insert(armoredCar, 0);
        }
        /// <summary>
        /// Добавление объекта в набор на конкретную позицию
        /// </summary>
        /// <param name="armoredCar">Добавляемый автомобиль</param>
        /// <param name="position">Позиция</param>
        /// <returns></returns>
        public int Insert(T armoredCar, int position)
        {
            if (position < 0 || position >= Count)
                return -1;
            
            if (!(_places[position] == null))
            {
                int index_empty = -1;
                // поиск первого пустого элемента
                for (int i = position + 1; i < Count; i++)
                {
                    if (_places[i] == null)
                    {
                        index_empty = i;
                    }
                }
                if (index_empty == -1)
                    return -1;
                else
                {
                    for (int i = index_empty; i > position; i--)
                    {                        
                        _places[i] = _places[i - 1];
                    }
                }
            }            
            _places[position] = armoredCar;
            return position;
        }
        /// <summary>
        /// Удаление объекта из набора с конкретной позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T Remove(int position)
        {
            if (position < 0 || position >= Count)
                return null;
            T armoredCar = _places[position];
            _places[position] = null;
            return armoredCar;
        }
        /// <summary>
        /// Получение объекта из набора по позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T Get(int position)
        {
            if (position < 0 || position >= Count)
                return null;
            return _places[position];
        }
    }
}
